<?php

namespace App\Classes\Modules\PerfexCRM\Services;

use Illuminate\Support\Facades\Http;
use App\Classes\Exceptions\MalformedRequestException;
use App\Classes\Exceptions\ConnectionErrorException;
use Illuminate\Support\Facades\Log;
use App\Classes\ValueObjects\Constants\PerfexCRMCustomFields;

class UpdatesPerfexCRMLead
{
    /**
     * @param $lead
     * @param string $companyReference
     * @return null|object
     * @throws MalformedRequestException
     */
    public function execute($lead, string $companyReference) {
        try{
            $custom_fields = [
                "leads" => [
                    PerfexCRMCustomFields::LEADS_SHIPPING_PORTAL_REFERENCE => $companyReference
                ]
            ];

            $data = [
                'name' => $lead->name,
                'email' => $lead->email,
                'phonenumber' => $lead->phonenumber,
                'company' => $lead->company,
                'custom_fields' => $custom_fields,
                'source' => $lead->source,
                'status' => $lead->status,
            ];

            $response = Http::asJson()->withHeaders([
                'authtoken' => config('perfexcrm.api_key')])
            ->put(config('perfexcrm.base_url').'/api/leads/'.$lead->id, $data);

            if($response->successful()){
                $data = $response->json();
                return (object) $data;
            }else{
                Log::channel('perfex_crm')->info('UpdatesPerfexCRMLead: '.$response);
                return null;
            }
        }
        catch(\Illuminate\Http\Client\ConnectionException $exception){
            $error = 'Failed to connect to CRM';
            throw new ConnectionErrorException($error, $exception->getMessage(), "", $exception->getTraceAsString());
        }
        catch(\Exception $exception){
            throw new MalformedRequestException('Unable to get correct response from Perfex CRM server: ' . $exception->getMessage());
        }
    }
}
